#ifndef __THE_MAZE_OF_GALIOUS_2_ACTIVE_INTERFACE
#define __THE_MAZE_OF_GALIOUS_2_ACTIVE_INTERFACE


class ActiveINTERFACE {
	friend class GameWindow;
	friend class GameDebugWindow;
	friend class NetworkGameWindow;

	friend class ActiveMOG2Application;
	friend class ActiveMOG2;
	friend class ActiveMAP;
	friend class ActiveOBJECT;

	friend class ActionSCRIPT;
	friend class ConditionSCRIPT;
	friend class ValueSCRIPT;

public:
	ActiveINTERFACE(MOG2_INTERFACE *interf,class ActiveMOG2 *game);
	~ActiveINTERFACE(void);

	bool save(FILE *fp);
	bool load(FILE *fp);

	bool cycle(class KEYBOARDSTATE **LVK,int n_LVKs);
	void draw(SDL_Surface *sfc,SDL_Rect vp);

	bool find_object(ActiveOBJECT *o);

	int get_variable_value(char *vname,int *ival,char **sval,ActiveOBJECT **oval);
	void set_variable_value(char *vname,int value);
	void set_variable_value(char *vname,char *value);
	void set_variable_value(char *vname,ActiveOBJECT *value);

private:
	List<VARIABLE> interface_variables;
	MOG2_INTERFACE *interf;

    ActiveMOG2 *game;

	class ActionSCRIPT *interface_action;
	class ActiveOBJECT *script_foreign_object;

	SDL_Surface *back_sfc;

	int interf_focusing_x,interf_focusing_y;

	// Interface objects: 
	List<ActiveOBJECT> objects[MAX_OBJECT_PLANES];

	List<ActiveOBJECT> objects_toadd[MAX_OBJECT_PLANES];
	List<ActiveOBJECT> objects_to_change_plane;

	List<class DRAWCOMMAND> draw_commands;

    // Quick lists:
    List<ActiveOBJECT> nonpassive_objects[MAX_OBJECT_PLANES];
};

#endif

